#!/bin/bash


# **
# * ------------------------------------------------------------------------
# * BlueMind Stats Portal, aka bm-stats
# * ------------------------------------------------------------------------
# * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
# * @author  : Pascal SALAUN 
# * @Website : http://www.breizh-ltd.com <http://www.breizh-ltd.com>
# * ------------------------------------------------------------------------
# **

# Remove the /var/log/mail* entries int the /etc/logrotate.d/syslog-g file
# 
#



file="/etc/logrotate.d/syslog-ng"

# First : doing a backup of this file
cp $file $file"-BM-BacKup.disabled"


parse_bloc() {

        first_line=$1
        file=$2
        ctrl_ok=

        for ((i=first_line;;i++))
        do
                mail_ctrl=`sed -n "$i"p $file`
                ligne_blanche=`sed -n "$i"p $file`

                if [ "$mail_ctrl" = "" ]; then
                        mail_ctrl=a
                fi

                if [ "$mail_ctrl" = "}" ]; then
                	ctrl_ok=1
                fi

                if [ "$ligne_blanche" = "" -a "$ctrl_ok" = "1" ]; then
                        iprev=$(($i-1));
                        echo "$first_line,$iprev"
                        break
                fi

                if [ "$ligne_blanche" = "" -a "$ctrl_ok" != "1" ]; then
                        echo "zz"
                        break
                fi

        done

}

deleting_mail_bloc() {

        line_mail=$1
        file=$2

        is_this_bloc=""

        # Getting the line numbers for each block in $file
        is_this_bloc=$(parse_bloc "$line_mail" $file);

        if [ "$is_this_bloc" != "zz" ]; then
                echo "deleting lines $is_this_bloc"
                sed -i "$is_this_bloc"d $file
        fi

}

# Parse $file to get the line number of each line '/var/log/mail."

line_mail=`grep -m 1 -n '/var/log/mail' $file | cut -d : -f 1`

while [ "$line_mail" ]
do

        deleting_mail_bloc "$line_mail" $file
        line_mail=`grep -m 1 -n '/var/log/mail' $file | cut -d : -f 1`

done

exit 0 ;
