#!/bin/bash

# **
# * ------------------------------------------------------------------------
# * BlueMind Stats Portal, aka bm-stats
# * ------------------------------------------------------------------------
# * @license : GNU Affero General Public License Version 3 <http://www.gnu.org/licenses>
# * @author  : Pascal SALAUN 
# * @Website : http://www.breizh-ltd.com <http://www.breizh-ltd.com>
# * ------------------------------------------------------------------------
# **


PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin
export PATH

# Author : Pascal Salaun <pascal.salaun@laposte.net>
# Description : do a logrotate of the mail.log file.
# Because these one can be hugh (over 1Go/day), the current savelog command
# will take too much time. (2 minutes for a 3.5Go file)
# So, this method will take only 1-2 seconds.



MailLogDir="/var/log/"
MailLogDestDir="/var/log/mail/"

LogDaemon="rsyslog"
Ownership=`ls -l /var/log/mail.log |tr -s " "|cut -d " " -f3,4|sed 's/ /:/'`


# Control
if [ ! -d $MailLogDestDir ]; then
        mkdir -p $MailLogDestDir
fi


# Get log daemon name (rsyslog/syslog-ng/sysklogd)
if [ "$LogDaemon" = "" ] ; then
	LogDaemon=`dpkg -l "*sys*log*" | grep ii | grep -iv perl | tr -s ' ' | cut -d ' ' -f2| grep -v system`
fi


# Logrotate

mv $MailLogDir"mail.log.0" $MailLogDir"mail.log."`date --date '2 days ago' +%F`
mv $MailLogDir"mail.log" $MailLogDir"mail.log.0"

touch $MailLogDir"mail.log"
chown $Ownership $MailLogDir"mail.log"
chmod 662 $MailLogDir"mail.log"

	

# Restart LogDaemon
/etc/init.d/$LogDaemon restart


# renamming, compressing, archiving mail.log.1
gzip -c $MailLogDir"mail.log."`date --date '2 days ago' +%F` > $MailLogDir"mail.log."`date --date '2 days ago' +%F`.gz
mv $MailLogDir"mail.log."`date --date '2 days ago' +%F`.gz $MailLogDestDir


# deleting the uncompressed mail.log.yyyy-mm-dd
rm -f  $MailLogDir"mail.log."`date --date '2 days ago' +%F`

# deleting the compressed file older than 1 year
rm -f  $MailLogDestDir"mail.log."`date --date '365 days ago' +%F`.gz

exit 0 ;

